/*
 * Legato is a configurable, lightweight web mapping client that can be
 * easily embedded into web pages and portals, CMS and individual web
 * applications. Legato is implemented in JavaScript and based on the
 * popular open source library OpenLayers.
 *
 * Copyright (C) 2010  disy Informationssysteme GmbH, http://www.disy.net
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

/**
 * Stuff to make headless testing possible
 */
LegatoTesting.Test.Headless = {};

/*
 * Please consider that this is some sort of a hack. It should been executed
 * automatically using JSUnit but till then we're doing it by hand.
 */
LegatoTesting.Test.Headless.run = function(testFunctionNames) {
  if (typeof setUpPage !== 'undefined') {
    logger.info("Executing setUpPage")
    setUpPage();
  }
  for ( var i = 0; i < testFunctionNames.length; ++i) {
    if (typeof setUp === 'function') {
      logger.info('Executing setUp');
      setUp();
    }

    logger.info('Run Test: ' + testFunctionNames[i] + '()');
    eval(testFunctionNames[i] + '()');

    if (typeof tearDown === 'function') {
      logger.info('Executing tearDown');
      tearDown();
    }
  }
}

JsUnitException.prototype.toString = function() {
  var result = '';
  if (this.comment)
    result += this.comment + ': ';
  result += this.jsUnitMessage;
  if (this.stackTrace)
    '[' + this.stackTrace + ']';
  return result;
}

function error(errorMessage) {
  throw new JsUnitException(null, errorMessage);
}

function exposeTestFunctionNames() {
  var testFunctionNames = [];
  for ( var name in this) {
    var target = this[name];
    if ((name.substring(0, 4) == 'test') && (typeof target == 'function')) {
      testFunctionNames.push(name);
    }
  }
  return testFunctionNames;
}